<script lang="ts">
  import type { PlayerId, State } from "../server";
  import CardFront from "./CardFront.svelte";
  import Discards from "./Discards.svelte";
  import Favor from "./icons/Favor.svelte";
  import { createActionDispatcher } from "./util/createActionDispatcher";

  const dispatchAction = createActionDispatcher();

  export let playerId: PlayerId | undefined;
  export let state: State;

  $: phase = state.phase as {
    kind: "RoundComplete";
    winners: PlayerId[];
    spy: PlayerId | null;
    ready: PlayerId[];
  };

  let playerScores: {
    [playerId: number]: { previous: number; current: number };
  };

  $: {
    playerScores = {};
    for (const player of state.players) {
      let scoreIncreased = 0;
      if (phase.winners.includes(player.id)) {
        scoreIncreased += 1;
      }
      if (phase.spy === player.id) {
        scoreIncreased += 1;
      }
      playerScores[player.id] = {
        previous: player.score - scoreIncreased,
        current: player.score,
      };
    }
  }
</script>

<section>
  <h2>Round summary</h2>
  <table>
    <thead>
      <tr>
        <th>Player</th>
        <th>Hand</th>
        <th>Discarded</th>
        <th>Points</th>
        <th>Total</th>
      </tr>
    </thead>
    <tbody>
      {#each state.players as player}
        <tr>
          <td class="player">
            <gs6-user playerid={player.id} />
          </td>
          <td class="hand">
            <div class="cards">
              {#if player.hand && player.hand[0] !== undefined}
                <CardFront card={player.hand[0]} />
              {/if}
            </div>
          </td>
          <td class="discards">
            <div class="cards">
              <Discards cards={player.discards} />
            </div>
          </td>
          <td>
            {#if phase.winners.includes(player.id)}
              <div>
                <span class="emoji">👑</span> ✕ 1
              </div>
            {/if}
            {#if phase.spy === player.id}
              <div>
                <span class="emoji">🕵️‍♀️</span> ✕ 1
              </div>
            {/if}
          </td>
          <td>
            <Favor /> ✕
            {#if playerScores[player.id].current !== playerScores[player.id].previous}
              <span class="new-score">{playerScores[player.id].current}</span>
            {:else}{playerScores[player.id].previous}{/if}
          </td>
        </tr>
      {/each}
    </tbody>
  </table>

  <div class="footer">
    {#if playerId !== undefined && !phase.ready.includes(playerId)}
      <p>
        <em>Prepare for the next round!</em>
      </p>
      <button
        class="primary"
        on:click={() => dispatchAction({ kind: "RoundComplete" })}
      >
        I'm ready!
      </button>
    {:else}
      <p>
        <em>Players are preparing for the next round!</em>
      </p>
    {/if}
  </div>
</section>

<style>
  section {
    padding: 1rem;
  }
  h2 {
    margin-bottom: 2rem;
  }

  section {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  table {
    border-spacing: 0;
  }
  th {
    border-bottom: #aaaa 1px solid;
    min-width: 6em;
  }

  th,
  td {
    padding-top: 0.25rem;
    padding-bottom: 0.25rem;
  }

  td {
    text-align: center;
  }
  td.player {
    text-align: left;
  }

  td.hand,
  td.discards {
    font-size: 0.33em;
    padding-inline-start: 1rem;
    padding-inline-end: 1rem;
  }

  .cards {
    display: grid;
    place-content: center;
  }

  .new-score {
    font-weight: 900;
  }

  em {
    font-weight: 300;
  }

  .footer {
    height: 7rem;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
  }
</style>
